//***************************************************************************
// File name:		main.cpp	
// Author:			Chadd Williams
// Date:				9/16/2013
// Class:				CS 380
// Assignment:	Vector Example
// Purpose:			Example code that stores pointers into vectors
//***************************************************************************


#define MEM_DEBUG 1
#include "mem_debug.h"
#include <vector>
#include <iostream>
#include <ctime>

//********************************************************
// Function:		main
//
// Description: Store pointers to ints into a vector and perform some
//							vector operations
//
// Parameters:  None
//
// Returned:		EXIT_SUCCESS on success, -1 otherwise
//	
//********************************************************
int main()
{
#ifdef MEM_DEBUG
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	//_crtBreakAlloc = 147;
#endif	

	/* vector of pointers */
	std::vector<int*> vecOfPointers;
	int *pInt;

	/* a forward iterator */
	std::vector<int*>::iterator iter;

	/* a reverse iterator */
	std::vector<int*>::reverse_iterator r_iter;

	srand(static_cast<unsigned int>(time(0)));

	for( int i = 0; i< 10; i++)
	{
		pInt = new int();

		// generate an integer between 0 and RAND_MAX
		*pInt = rand();

		// put the pointer on the end of the vector
		vecOfPointers.push_back(pInt);

		std::cout<< *vecOfPointers[i] << " " ; 
	}


	std::cout << "\n\n VECTOR FORWARD: \n\n";

	// use the iterator to walk forward
	iter = vecOfPointers.begin();
	while ( iter != vecOfPointers.end() )
	{
		// outside star: dereference the int
		// inside star:  dereference the iterator
		std::cout << *(*iter) << std::endl;

		// increase the iterator
		iter ++;
	}

	std::cout << "\n\n VECTOR REVERSE: \n\n";

	// use the iterator to walk backwards
	r_iter = vecOfPointers.rbegin();
	while ( r_iter != vecOfPointers.rend() )
	{
		std::cout << *(*r_iter) << std::endl;

		// still ++
		r_iter ++;
	}

	std::cout << "\n\n VECTOR FORWARD: \n\n";
	// you can also use array notation with a vector
	for (int index = 0 ; index < vecOfPointers.size() ; index++)
	{
		std::cout << *(vecOfPointers[index]) << std::endl;
	}

	std::cout << "\n\n VECTOR DEALLOCATE \n\n";

	for (int index = 0 ; index < vecOfPointers.size() ; index++)
	{
		// you can also use array notation with a vector
		// to set values
		delete vecOfPointers[index];
		vecOfPointers[index] = NULL;
	}
	
	return EXIT_SUCCESS;
}
